/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/* Gateway db utility
 * Europagate, 1995
 *
 * $Log: gw-db.h,v $
 * Revision 1.4  1995/12/20 16:27:18  adam
 * Extra parameter block to gw_db_open.
 *
 * Revision 1.3  1995/05/16  09:39:39  adam
 * LICENSE.
 *
 * Revision 1.2  1995/04/17  09:33:05  adam
 * ttyemit moved from kernel directory. Minor editing in gw-db.h
 *
 * Revision 1.1  1995/03/27  08:23:18  adam
 * First version of gip interface (gateway IPc).
 * First version of gw-db: gateway hash db.
 *
 */
#ifndef GW_DB_H
#define GW_DB_H

typedef struct gw_db *GW_DB;

int   gw_db_lookup (GW_DB db, const char *name, int name_length,
                    void **buf, size_t *count);
int   gw_db_insert (GW_DB db, const char *name, int name_length,
                    const void *buf, size_t count);
GW_DB gw_db_open   (const char *fname, int write_flag, int block);
int   gw_db_close  (GW_DB db);

int   gw_db_no_ent (GW_DB db);
int   gw_db_seq_no (GW_DB db);

#endif
