/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
/* Utility: Read line from FIFO
 * Europagate, 1995
 *
 * $Log: lgets.c,v $
 * Revision 1.4  1995/05/16 09:40:55  adam
 * LICENSE.
 *
 * Revision 1.3  1995/05/03  12:18:55  adam
 * This code ran on dtbsun. Minor changes.
 *
 * Revision 1.2  1995/05/02  15:26:52  adam
 * EINTR obvserved on reads and writes.
 *
 * Revision 1.1  1995/05/01  12:43:58  adam
 * lgets function moved from kernel to util.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>

#include <gw-log.h>

#include <lgets.h>

int lgets (char *buf, int max, int fd)
{
    int r, no = 0;

    --max;
    while (no <= max)
    {
        while (1)
        {
            if ((r=read (fd, buf+no, 1)) == 1)
                break;
            if (r == -1 && errno == EINTR)
                continue;
	    if (r == -1)
		gw_log (GW_LOG_WARN|GW_LOG_ERRNO, "lgets", "read fail");
	    else
                gw_log (GW_LOG_WARN, "lgets", "read eof");
	    buf[no] = '\0';
	    return 0;
	}
	if (buf[no] == 1)
            return 0;	  
	if (buf[no++] == '\n')
	    break;
    }
    buf[no] = '\0';	
    return 1;
}

